<?php
// +----------------------------------------------------------------------
// | 不基于反射机制：实现注释生成文档
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

class ApiWord {
    /**
     * 获得文件说明
     * @todo 无
     * @author 小黄牛
     * @version v1.0.0.1 + 2018.10.08
     * @deprecated 暂不弃用
     * @global 无
     * @param string $dir 目录地址
     * @return array
    */
    public function run($dir) {
        if(!is_dir($dir)) return false;
        $handle = opendir($dir);
        $array  = [];
        if($handle){
            // 获取基础的控制器
            while (($fl = readdir($handle)) !== false) {
                $temp = $dir.$fl;
                if (!is_dir($temp) && $fl!='.' && $fl != '..') {
                    $className = str_replace('.php', '', $fl);
                    if ($className == 'Error') continue;

                    $data['name']  = $className;
                    $data['title'] = str_replace('控制器', '', $this->getLine($temp, 3));
                    $data['auth']  = $this->getLine($temp, 9);
                    $array[] = $data;
                }
            }
        }
        // 获取对应接口
        foreach ($array as $k=>$v) {
            $file = $dir.$v['name'].'/';
            $handle = opendir($file);
            $list  = [];
            if($handle){
                while (($fl = readdir($handle)) !== false) {
                    $temp = $file.$fl;
                    if (!is_dir($temp) && $fl!='.' && $fl != '..') {
                        $className = str_replace('.php', '', $fl);
                        $arr['name']  = $className;
                        $arr['title'] = $this->getLine($temp, 3);
                        $arr['auth']  = $this->getLine($temp, 9);
                        $arr['word']  = '未编写';

                        $content = file_get_contents($temp);
                        $exp = explode('_link()', $content);
                        if (!empty($exp[1])) {
                            $exp = explode('}', $exp[1]);
                            $exp = explode('{', $exp[0]);
                            if (!empty($exp[1])) {
                                $html = '';
$exp = explode("
", $exp[1]);
                                foreach ($exp as $kk=>$val) {
                                    if ($kk == 0) continue;
                                    $x = explode('        ', $val);
                                    foreach ($x as $key => $value) {
                                        if ($key == 0) continue;
                                        if ($value == '') $value = '        ';
                                        $html .= $value;
                                    }
                                    $html .= "\r\n";
                                }
                                $arr['word']  = $html;
                            }
                        }
                        
                        $list[] = $arr;
                    }
                }
            }
            $array[$k]['list'] = $list;
        }

        return $array;
    }

    /**
    * 获取指定行内容
    * @todo 无
    * @author 小黄牛
    * @version v1.0.0.1 + 2018.10.08
    * @deprecated 暂不弃用
    * @global 无
    * @param string $file 文件路径
    * @param int $line 行数
    * @param int $length 指定行返回内容长度
    * @return string
    */
    private function getLine($file, $line, $length = 4096){
        $returnTxt = null;                // 初始化返回
        $i         = 1;                   // 行数
        $handle    = @fopen($file, "r");
        if ($handle) {
            while (!feof($handle)) {
                $buffer = fgets($handle, $length);
                if($line == $i) $returnTxt = str_replace(['// | ', 'Author: ', '<', '>'], '', $buffer);
                $i++;
            }
            fclose($handle);
        }
        return $returnTxt;
    }
}