<?php
// +----------------------------------------------------------------------
// | 删除管理员操作日志
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;

class admin_action_delete extends _Admin
{

    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        return $this->delete($param);
    }
    
    // 删除登录日志
    private function delete($param=[]) {

        $num = 0;
        $i   = 0;
        foreach ($param as  $key=>$val) {
            $num++;
            $table = \org\SubTable::init('auth_admin_action')->hash($val['admin']);
            $res = \think\Db::name($table)->where('id', $val['id'])->delete();
            if ($res != false) {
                $i++;
            }
        }
        
        return $this->_json('00', "共：{$num}条数据，成功删除：{$i}条！");
    }

}
